//------------------------------------------------------------------
//
//
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  PaleVioletRed
#property indicator_color2  LimeGreen

extern int period=15;

double cfhd[];
double cfhu[];
double cfl[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,cfhd); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,cfhu); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,cfl);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      double N=0,M=0;
   	for (int cnt=period; cnt>=1; cnt--)
      { 
         N += cnt*cnt;
         M += cnt;
      }
      for(int i = limit; i >= 0; i--)
      {
         double ZYVar         = 0;
         double TYVar         = 0;
         double ZIndicatorVar = 0;
         double TIndicatorVar = 0;
         for (int k=period; k>0; k--) 
         {
            double tmp = iMA(NULL,0,1,0,MODE_SMA,PRICE_MEDIAN ,i+k-1);
                        ZYVar += tmp*(period-k+1);
                        TYVar += tmp;
                   tmp = iMA(NULL,0,5,0,MODE_SMMA,PRICE_MEDIAN,i+k+2);
                        ZIndicatorVar += tmp*(period-k+1);
                        TIndicatorVar += tmp;
         }
         double AY         = (TYVar        +(N-2*ZYVar        )*period/M)/M;
         double AIndicator = (TIndicatorVar+(N-2*ZIndicatorVar)*period/M)/M;
      	if (StringFind(Symbol(),"JPY",0)>=2)
      	     cfl[i]  = ( 1000)*MathLog(AY/AIndicator);
      	else cfl[i]  = (-1000)*MathLog(AY/AIndicator);
      	     cfhu[i] = EMPTY_VALUE;
      	     cfhd[i] = EMPTY_VALUE;
      	     if (cfl[i] > 0) { cfhu[i]= High[i]; cfhd[i]= Low[i]; }
      	     if (cfl[i] < 0) { cfhd[i]= High[i]; cfhu[i]= Low[i]; }
   }
   return(0);
}